package com.szpg.plc.message.response.read;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

import com.szpg.db.dao.PgDeviceDao;
import com.szpg.db.dao.PgHjsbblDao;
import com.szpg.db.dao.PgSbDao;
import com.szpg.db.dao.impl.PgDeviceDaoImpl;
import com.szpg.db.dao.impl.PgHjsbblDaoImpl;
import com.szpg.db.dao.impl.PgSbDaoImpl;
import com.szpg.db.data.PgHjsbbl;
import com.szpg.plc.message.response.ReadMemoryCommandResponse;
import com.szpg.plc.util.ByteUtil;
import com.szpg.util.Configure;
import com.szpg.util.TimeFormat;

public class ReadSbStatCommandResponse extends ReadMemoryCommandResponse {

	/**
	 * 
	 */
	private static final long serialVersionUID = -860746446736533413L;

	private final Logger logger = Logger.getLogger(this.getClass().getName());

	private List<Boolean> sb1Flt;
	private List<Boolean> sb2Flt;
	private List<Boolean> sb1Run;
	private List<Boolean> sb2Run;
	private String[] zcList; // 资产列表，从配置文件中获取

	public ReadSbStatCommandResponse() {
		sb1Flt = new ArrayList<Boolean>();
		sb2Flt = new ArrayList<Boolean>();
		sb1Run = new ArrayList<Boolean>();
		sb2Run = new ArrayList<Boolean>();
	}

	public List<Boolean> getSb1Flt() {
		return sb1Flt;
	}

	public void setSb1Flt(List<Boolean> sb1Flt) {
		this.sb1Flt = sb1Flt;
	}

	public List<Boolean> getSb2Flt() {
		return sb2Flt;
	}

	public void setSb2Flt(List<Boolean> sb2Flt) {
		this.sb2Flt = sb2Flt;
	}

	public List<Boolean> getSb1Run() {
		return sb1Run;
	}

	public void setSb1Run(List<Boolean> sb1Run) {
		this.sb1Run = sb1Run;
	}

	public List<Boolean> getSb2Run() {
		return sb2Run;
	}

	public void setSb2Run(List<Boolean> sb2Run) {
		this.sb2Run = sb2Run;
	}

	public String[] getZcList() {
		return zcList;
	}

	public void setZcList(String[] zcList) {
		this.zcList = zcList;
	}

	@Override
	public void afterAction() {
		// 1将水泵运行状态数据存入数据库
		PgSbDao sbDao = new PgSbDaoImpl();
		PgDeviceDao deviceDao = new PgDeviceDaoImpl();

		if (null != zcList && zcList.length > 0) {
			// 遍历设备列表，将水泵运行状态存入数据库
			for (int i = 0; i < zcList.length; i++) {
				String zcbh = zcList[i];

				int id = deviceDao.findDeviceIdByCode(zcbh);
				if (id > 0) {
					// 根据是否有数据来判断单泵还是双泵
					if (null == sb2Run.get(i)) {
						sbDao.addStatRecord(sb1Run.get(i), sb1Flt.get(i), TimeFormat.formatTimestamp(this.getTime().getTime()), id);
					} else {
						sbDao.addStatRecord(sb1Run.get(i), sb2Run.get(i), sb1Flt.get(i), sb2Flt.get(i), TimeFormat.formatTimestamp(this.getTime().getTime()), id);
					}
				}
			}
		}
	}

	@Override
	public void parseData(byte[] messageData) {
		// 获取目标ACU的代码
		String acucode = this.getAcucode();

		// 判断数据的长度是否满足要求
		if (messageData.length != Integer.parseInt(Configure.getProperty("acubl", acucode + ".SBSTAT.WORDCOUNT")) * 2) {
			logger.error("返回的数据长度与读取的不一致！");
			this.setValid(false);
			return;
		}

		// 将数据转换为字符串
		// 按照高字在前，低字在后；高字节在前，低字节在后的顺序
		String dataStr = "";
		for (int c = 0; c < messageData.length; c = c + 2) {
			dataStr = ByteUtil.binToBinString(new byte[] { messageData[c], messageData[c + 1] }) + dataStr;
		}

		PgHjsbblDao blDao = new PgHjsbblDaoImpl();

		// 获取目标ACU水泵运行状态内存区域的起始字地址
		int start = Integer.parseInt(Configure.getProperty("acubl", acucode + ".SBSTAT.START"));

		// 获取目标ACU水泵相关的资产列表，即水泵列表
		String zcListStr = Configure.getProperty("acubl", acucode + ".SB.ZC.LIST");
		if (StringUtils.isEmpty(zcListStr) == true) {
			this.setValid(false);
			return;
		}
		zcList = zcListStr.split(";");

		// 解析水泵运行状态
		for (int i = 0; i < zcList.length; i++) {
			String zcbh = zcList[i];

			// 解析水泵1运行状态
			PgHjsbbl run1BlObj = blDao.findBlByBh(zcbh + ".Run1");
			if (null == run1BlObj) {
				continue;
			}

			int r1kszdz = run1BlObj.getKszdz(); // 开始字地址
			int r1offset = r1kszdz - start; // 与开始字的偏移量
			int r1bit = run1BlObj.getSzw(); // 所在位

			char run1Bt = dataStr.charAt(dataStr.length() - 1 - r1offset * 16 - r1bit); // 水泵1运行状态标志位
			
			// 解析水泵2运行状态
			PgHjsbbl run2BlObj = blDao.findBlByBh(zcbh + ".Run2");
			if (null == run2BlObj) {
				getSb2Run().add(null);
			} else {
				int r2kszdz = run2BlObj.getKszdz(); // 开始字地址
				int r2offset = r2kszdz - start; // 与开始字的偏移量
				int r2bit = run2BlObj.getSzw(); // 所在位

				char run2Bt = dataStr.charAt(dataStr.length() - 1 - r2offset * 16 - r2bit); // 水泵2运行状态标志位
				getSb2Run().add(run2Bt == '1' ? true : false);
			}

			// 解析水泵1故障报警状态
			PgHjsbbl flt1BlObj = blDao.findBlByBh(zcbh + ".Flt1");
			if (null == flt1BlObj) {
				continue;
			}

			int f1kszdz = flt1BlObj.getKszdz(); // 开始字地址
			int f1offset = f1kszdz - start; // 与开始字的偏移量
			int f1bit = flt1BlObj.getSzw(); // 所在位

			char flt1Bt = dataStr.charAt(dataStr.length() - 1 - f1offset * 16 - f1bit); // 水泵1故障报警标志位

			// 解析水泵2故障报警状态
			PgHjsbbl flt2BlObj = blDao.findBlByBh(zcbh + ".Flt2");
			if (null == flt2BlObj) {
				getSb2Flt().add(null);
			} else {

				int f2kszdz = flt2BlObj.getKszdz(); // 开始字地址
				int f2offset = f2kszdz - start; // 与开始字的偏移量
				int f2bit = flt2BlObj.getSzw(); // 所在位
	
				char flt2Bt = dataStr.charAt(dataStr.length() - 1 - f2offset * 16 - f2bit); // 水泵1故障报警标志位
				getSb2Flt().add(flt2Bt == '1' ? true : false);
			}
			
			getSb1Flt().add(flt1Bt == '1' ? true : false);
			getSb1Run().add(run1Bt == '1' ? true : false);
		}
	}

}
